<nz-page-header nzBackIcon nzTitle="Mod panel - Dashboard"></nz-page-header>

<div *ngIf="!isMod" style="text-align: center;">
  <h2>Prove you are you.</h2>

  <input nz-input [(ngModel)]="verifyCode" style="width: 60%; margin-bottom: 10px;" />
  <br />
  <button nz-button nzShape="round" nzType="primary" (click)="verify()">
    Verify me
  </button>

  <button nz-button nzShape="round" nzDanger (click)="reset2fa()" style="margin-left: 30px">
    Reset 2FA
  </button>
</div>

<nz-spin [nzSpinning]="isLoading" *ngIf="isMod">
  <nz-tabset (nzSelectChange)="onTabChange($event)">
    <nz-tab nzTitle="Newest entities reports">
      <nz-table #basicTable [nzData]="list" nzSize="small" *ngIf="currentIndex === 0">
        <thead>
          <tr>
            <th nzAlign="center">Type</th>
            <th nzAlign="center">Entity</th>
            <th nzAlign="center">Reason</th>
            <th nzAlign="center">Status</th>
            <th nzAlign="center">Created on</th>
            <th nzAlign="center">Created by</th>
            <th nzAlign="center"></th>
          </tr>
        </thead>
        <tbody>
          @for (data of basicTable.data; track data) {
          <tr>
            <td nzAlign="center">{{ data.entity.type }}</td>
            <td nzAlign="center">
              <a [routerLink]="['/', data.entity.type.toLowerCase(), data.entity.id]">{{ data.entity.name }}</a>
            </td>
            <td nzAlign="center">{{ data.reason }}</td>
            <td nzAlign="center">{{ data.status }}</td>
            <td nzAlign="center">{{ data.createdOn }}</td>
            <td nzAlign="center">
              <a [routerLink]="['/citizen', data.createdBy.id]">{{ data.createdBy.name }}</a>
            </td>
            <td></td>
          </tr>
          }
        </tbody>
      </nz-table>
    </nz-tab>

    <!-- SHARED IP -->
    <nz-tab nzTitle="Shared of IP">
      <ng-template nz-tab>
        <nz-table #basicTable [nzData]="list" nzSize="small" *ngIf="currentIndex === 1">
          <thead>
            <tr>
              <th nzAlign="center">IP</th>
              <th nzAlign="center">Citizens count</th>
              <!-- <th nzAlign="center">Notes</th> -->
              <th nzAlign="center"></th>
            </tr>
          </thead>
          <tbody>
            @for (data of basicTable.data; track data) {
            <tr>
              <td nzAlign="center">{{ data.ipAddress }}</td>
              <td nzAlign="center">{{ data.citizens?.length }}</td>
              <!-- <td nzAlign="center"></td> -->
              <td nzAlign="center">
                <button nz-button nzSize="small" nzShape="round" (click)="shareIpDetails = data">
                  <span nz-icon nzType="eye" nzTheme="outline"></span>
                </button>
              </td>
            </tr>
            }
          </tbody>
        </nz-table>
      </ng-template>
    </nz-tab>

    <!-- SHARED PASSWORD -->
    <nz-tab nzTitle="Share of password">
      <ng-template nz-tab>
        <nz-table #basicTable [nzData]="list" nzSize="small" *ngIf="currentIndex === 2">
          <thead>
            <tr>
              <th nzAlign="center">PASSWORD</th>
              <th nzAlign="center">Citizens count</th>
              <!-- <th nzAlign="center">Notes</th> -->
              <th nzAlign="center"></th>
            </tr>
          </thead>
          <tbody>
            @for (data of basicTable.data; track data) {
            <tr>
              <td nzAlign="center">{{ data.password }}</td>
              <td nzAlign="center">{{ data.citizens?.length }}</td>
              <!-- <td nzAlign="center"></td> -->
              <td nzAlign="center">
                <button nz-button nzSize="small" nzShape="round" (click)="sharePasswordDetails = data">
                  <span nz-icon nzType="eye" nzTheme="outline"></span>
                </button>
              </td>
            </tr>
            }
          </tbody>
        </nz-table>
      </ng-template>
    </nz-tab>

  </nz-tabset>
</nz-spin>

<nz-modal *ngIf="shareIpDetails" nzTitle="Details of IP: {{ shareIpDetails.ipAddress }}" nzVisible
  (nzOnCancel)="shareIpDetails = undefined" [nzFooter]="null" nzWidth="80%" nzMaskClosable="false">
  <ng-container *nzModalContent>
    <nz-table #shareIpDetailsTable [nzData]="shareIpDetails.citizens" nzSize="small">
      <thead>
        <tr>
          <th nzAlign="center">Name</th>
          <th nzAlign="center">Count</th>
          <th nzAlign="center">Last accessed</th>
        </tr>
      </thead>
      <tbody>
        @for (data of shareIpDetailsTable.data; track data) {
        <tr>
          <td nzAlign="center">
            <a [routerLink]="['/citizen', data.id]">
              {{ data.name }}
            </a>
          </td>
          <td nzAlign="center">{{ data.count }}</td>
          <td nzAlign="center">{{ data.lastAccessed }}</td>
        </tr>
        }
      </tbody>
    </nz-table>
  </ng-container>
</nz-modal>

<nz-modal *ngIf="sharePasswordDetails" nzTitle="Details of Password: {{ sharePasswordDetails.password }}" nzVisible
  (nzOnCancel)="sharePasswordDetails = undefined" [nzFooter]="null" nzWidth="80%" nzMaskClosable="false">
  <ng-container *nzModalContent>
    <nz-table #sharePasswordDetailsTable [nzData]="sharePasswordDetails.citizens" nzSize="small">
      <thead>
        <tr>
          <th nzAlign="center">Name</th>
          <th nzAlign="center">Last accessed</th>
        </tr>
      </thead>
      <tbody>
        @for (data of sharePasswordDetailsTable.data; track data) {
        <tr>
          <td nzAlign="center">
            <a [routerLink]="['/citizen', data.id]">
              {{ data.name }}
            </a>
          </td>
          <td nzAlign="center">{{ data.lastAccessed }}</td>
        </tr>
        }
      </tbody>
    </nz-table>
  </ng-container>
</nz-modal>
